# -*- coding: utf-8 -*-
"""
Created on Wed Mar 02 14:28:45 2016

@author: vilem.klepac
"""

import math
import sympy
import numpy as np
#import matplotlib
import matplotlib.pyplot as plt
from sympy import solve

from vstupy import Mk, Ft, Fret, d1, d2, d3, d4, d5, d6, d7, l1, l2, l3, l4, l5, l6, l7, Fr, Beta

d1=float (d1)
d2=float (d2)
d3=float (d3)
d4=float (d4)
d5=float (d5)
d6=float (d6)
d7=float (d7)

dok=480

WoI=math.pi*(d1**3)/32
WoII=math.pi*(d2**3)/32
WoIII=math.pi*(d3**3)/32
WoIV=math.pi*(d4**3)/32
WoV=math.pi*(d5**3)/32
WoVI=math.pi*(d6**3)/32
WoVII=math.pi*(d7**3)/32


lrl=d7*np.sin(15*math.pi/180)#posunutí působišť sil v kuželíkových ložiskách
l7=l7-2*lrl

lskIII=l1+l2+30
lskV=l1+l2+l3+l4+l5-30
lVI=l1+l2+l3+l4+l5+l6
lVII=l1+l2+l3+l4+l5+l6+lrl
lF=lVII+l7/2
lH=l1+l2+l3+l4+l5+l6+l7

x=sympy.Symbol('x')

Ra=sympy.Symbol('Ra')
Rb=sympy.Symbol('Rb')
Rc=sympy.Symbol('Rc')

Ray=sympy.Symbol('Ray')
Rby=sympy.Symbol('Rby')
Rcy=sympy.Symbol('Rcy')

ra=sympy.Symbol('ra')
rb=sympy.Symbol('rb')

rovnice=[ra+rb-1,rb*lVII-1*lH]
vysledek=solve(rovnice, ra, rb)

ra=vysledek [ra]
rb=vysledek [rb]

I=Ra*x
II=Ra*x
IIIa=Ra*x
IIIb=Ra*x-Fret*(x-lskIII)
IV=Ra*x-Fret*(x-lskIII)
Va=Ra*x-Fret*(x-lskIII)
Vb=Ra*x-Fret*(x-lskIII)-Fret*(x-lskV)
VI=Ra*x-Fret*(x-lskIII)-Fret*(x-lskV)
VIIa=Ra*x-Fret*(x-lskIII)-Fret*(x-lskV)
VIIb=Ra*x-Fret*(x-lskIII)-Fret*(x-lskV)+Rb*(x-lVII)
VIIc=Ra*x-Fret*(x-lskIII)-Fret*(x-lskV)+Rb*(x-lVII)-Ft*np.sin(Beta)*(x-lF)-Fr*np.cos(Beta)

i=ra*x
ii=ra*x
iiia=ra*x
iiib=ra*x
iv=ra*x
va=ra*x
vb=ra*x
vi=ra*x
viia=ra*x
viib=ra*x+rb*(x-lVII)
viic=ra*x+rb*(x-lVII)

MI=sympy.integrate(I*i,(x,0,l1))
MI=MI/(d1**4)
MII=sympy.integrate(II*ii,(x,l1,l1+l2))
MII=MII/(d2**4)
MIIIa=sympy.integrate(IIIa*iiia,(x,l1+l2,lskIII))
MIIIa=MIIIa/(d3**4)
MIIIb=sympy.integrate(IIIb*iiib,(x,lskIII,l1+l2+l3))
MIIIb=MIIIb/(d3**4)
MIV=sympy.integrate(IV*iv,(x,l1+l2+l3,l1+l2+l3+l4))
MIV=MIV/(d4**4)
MVa=sympy.integrate(Va*va,(x,l1+l2+l3+l4,lskV))
MVa=MVa/(d5**4)
MVb=sympy.integrate(Vb*vb,(x,lskV,l1+l2+l3+l4+l5))
MVb=MVb/(d5**4)
MVI=sympy.integrate(VI*vi,(x,l1+l2+l3+l4+l5,l1+l2+l3+l4+l5+l6))
MVI=MVI/(d6**4)
MVIIa=sympy.integrate(VIIa*viia,(x,l1+l2+l3+l4+l5+l6,lVII))
MVIIa=MVIIa/(d7**4)
MVIIb=sympy.integrate(VIIb*viib,(x,lVII,lF))
MVIIb=MVIIb/(d7**4)
MVIIc=sympy.integrate(VIIc*viic,(x,lF,lH))
MVIIc=MVIIc/(d7**4)

eqvals=[MI+MII+MIIIa+MIIIb+MIV+MVa+MVb+MVI+MVIIa+MVIIb+MVIIc, -Ra-Rb-Rc+2*Fret-Ft, Fret*lskIII+Fret*lskV-Rb*lVII-Ft*lF-Rc*lH]
result=solve(eqvals, Ra, Rb, Rc)

Ra=result[Ra]
Rb=result[Rb]
Rc=result[Rc]

print "Ra", Ra, "Rb", Rb, "Rc", Rc
#-----------------------------------------------
Iy=Ray*x
IIy=Ray*x
IIIay=Ray*x
IIIby=Ray*x
IVy=Ray*x
Vay=Ray*x
Vby=Ray*x
VIy=Ray*x
VIIay=Ray*x
VIIby=Ray*x+Rby*(x-lVII)
VIIcy=Ray*x+Rby*(x-lVII)-Ft*np.cos(Beta)*(x-lF)-Fr*np.sin(Beta)

MIy=sympy.integrate(Iy*i,(x,0,l1))
MIy=MIy/(d1**4)
MIIy=sympy.integrate(IIy*ii,(x,l1,l1+l2))
MIIy=MIIy/(d2**4)
MIIIay=sympy.integrate(IIIay*iiia,(x,l1+l2,lskIII))
MIIIay=MIIIay/(d3**4)
MIIIby=sympy.integrate(IIIby*iiib,(x,lskIII,l1+l2+l3))
MIIIby=MIIIby/(d3**4)
MIVy=sympy.integrate(IVy*iv,(x,l1+l2+l3,l1+l2+l3+l4))
MIVy=MIVy/(d4**4)
MVay=sympy.integrate(Vay*va,(x,l1+l2+l3+l4,lskV))
MVay=MVay/(d5**4)
MVby=sympy.integrate(Vby*vb,(x,lskV,l1+l2+l3+l4+l5))
MVby=MVby/(d5**4)
MVIy=sympy.integrate(VIy*vi,(x,l1+l2+l3+l4+l5,l1+l2+l3+l4+l5+l6))
MVIy=MVIy/(d6**4)
MVIIay=sympy.integrate(VIIay*viia,(x,l1+l2+l3+l4+l5+l6,lVII))
MVIIay=MVIIay/(d7**4)
MVIIby=sympy.integrate(VIIby*viib,(x,lVII,lF))
MVIIby=MVIIby/(d7**4)
MVIIcy=sympy.integrate(VIIcy*viic,(x,lF,lH))
MVIIcy=MVIIcy/(d7**4)

eqvalsy=[MIy+MIIy+MIIIay+MIIIby+MIVy+MVay+MVby+MVIy+MVIIay+MVIIby+MVIIcy, -Ray-Rby-Rcy+Ft*np.cos(Beta)+Fr*np.sin(Beta), Ray*(l1+l2+l3+l4+l5+l6+l7)+Rby*(l7)-Ft*np.cos(Beta)*l7/2-Fr*np.sin(Beta)]
resulty=solve(eqvalsy, Ray, Rby, Rcy)

Ray=resulty[Ray]
Rby=resulty[Rby]
Rcy=resulty[Rcy]

print "Ray", Ray, "Rby", Rby, "Rcy",Rcy

Ra=math.pow(Ra**2+Ray**2,0.5)
Rb=math.pow(Rb**2+Rby**2,0.5)
Rc=math.pow(Rc**2+Rcy**2,0.5)

SigmaoI=(Ra*l1)/WoI
SigmaoIIa=(Ra*(l1+l2))/WoII
SigmaoIIIa=((Ra*(l1+l2+l3)-Fret*((l1+l2+l3)-lskIII))/WoIV)
SigmaoIIIb=((Ra*(l1+l2+l3+l4)-Fret*((l1+l2+l3+l4)-lskIII))/WoIV)
SigmaoIIb=((Ra*(l1+l2+l3+l4+l5)-Fret*(l1+l2+l3+l4+l5-lskIII)-Fret*(l1+l2+l3+l4+l5-lskV))/WoVI)
SigmaoIV=((Ra*(l1+l2+l3+l4+l5+l6)-Fret*(l1+l2+l3+l4+l5+l6-lskIII)-Fret*(l1+l2+l3+l4+l5+l6-lskV))/WoVII)

print "Vypocet ohybove sily OK"